%define _default_patch_fuzz 1
%define Werror_cflags %nil

# Csound is really dumb about 64-bit
%ifarch x86_64 ia64
%define build64bit 1
%define install64bit --word64
%define useDouble 1
%else
%define build64bit 0
%define install64bit %{nil}
%define useDouble 0
%endif

Summary:	A sound synthesis language and library
Name:		csound
Version:	5.17.11
Release:	%mkrel 3
License:	LGPLv2+
Group:		Sound/Utilities
URL:		http://csound.sourceforge.net/

Source0:	http://downloads.sourceforge.net/csound/Csound%{version}.tar.gz
# git archive --remote git://csound.git.sourceforge.net/gitroot/csound/manual \
# --format tar Csound-5.17 --prefix=manual/ -o Csound5.17-manual-src.tar
# gzip Csound5.17-manual-src.tar
Source1:	http://downloads.sourceforge.net/csound/Csound5.17-manual-src.tar.gz
Source2:	http://downloads.sourceforge.net/csound/Csound5.17_manual_html.zip
Source3:	custom.py

Patch0:		csound-fixpython.patch
Patch1:		csound-5.13.0-no-usr-local.patch
Patch2:		csound-5.13.0-default-opcodedir.patch
Patch3:		csound-5.10.1-rtalsa-fix.patch
Patch4:		csound-5.13.0-makebuild.patch
Patch5:		csound-5.10.1-64-bit-plugin-path.patch
Patch6:		csound-5.13.0-fix-conflicts.patch
Patch7:		csound-5.13.0-fix-locale-install.patch
Patch8:		csound-5.10.1-enable-oggplay.patch
Patch10:	csound-default-pulse.patch
Patch11:	csound-5.17.11-bison26.patch

BuildRequires:	swig scons
BuildRequires:	libsndfile-devel
BuildRequires:	png-devel
BuildRequires:	jpeg-devel
BuildRequires:	python-devel
BuildRequires:	pkgconfig(alsa)
BuildRequires:	libjack-devel
BuildRequires:	pulseaudio-devel
BuildRequires:	fluidsynth-devel
BuildRequires:	liblo-devel
BuildRequires:	dssi-devel
BuildRequires:	lua5.1-devel
BuildRequires:	luajit-devel
BuildRequires:	fltk-devel
BuildRequires:	java-devel >= 1.4.0
BuildRequires:	jpackage-utils >= 1.5
BuildRequires:	java-gcj-compat-devel
BuildRequires:	tk-devel
BuildRequires:	tcl-devel
BuildRequires:	tetex
BuildRequires:	tetex-latex
BuildRequires:	libxslt-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libogg-devel
BuildRequires:	gettext
BuildRequires:	gcc-c++
BuildRequires:	boost-devel
BuildRequires:	bison flex

Obsoletes:	csound-tutorial <= 5.08
Obsoletes:	olpcsound <= 5.10.90

%description
Csound is a sound and music synthesis system, providing facilities for
composition and performance over a wide range of platforms. It is not
restricted to any style of music, having been used for many years in
at least classical, pop, techno, ambient...

%package	devel
Summary:	Csound development files and libraries
Group:		Development/C
Requires:	%{name} = %{version}-%{release}
Obsoletes:	olpcsound-devel <= 5.10.90
Conflicts:	%{name}-python < 5.13.0-3

%description	devel
Contains headers and libraries for developing applications that use Csound.

%package	python
Summary:	Python Csound development files and libraries
Group:		Development/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python

%description	python
Contains Python language bindings for developing Python applications that
use Csound.

%package	java
Summary:	Java Csound support
Group:		Development/Java
Requires:	%{name} = %{version}-%{release}
Requires:	jpackage-utils >= 1.5
Requires:	java-1.5.0-gcj
Requires(post):	jpackage-utils >= 1.5
Requires(postun): jpackage-utils >= 1.5
Requires(post):	java-gcj-compat
Requires(postun): java-gcj-compat

%description	java
Contains Java language bindings for developing and running Java
applications that use Csound.

%package	javadoc
Summary:	API documentation for Java Csound support
Group:		Development/Java

%description	javadoc
API documentation for the %{name}-java package.

%package	tk
Summary:	Tcl/Tk related Csound utilities
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}
Requires:	tcl tk

%description	tk
Contains Tcl/Tk related Csound utilities

%package	gui
Summary:	A FLTK-based GUI for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}
Requires:	fltk xdg-utils

%description	gui
Contains a FLTK-based GUI for Csound

%package	fltk
Summary:	FLTK plugins for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}
Requires:	fltk

%description	fltk
Contains FLTK plugins for csound

%package	jack
Summary:	Jack Audio plugins for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}
Requires:	jackit

%description	jack
Contains Jack Audio plugins for Csound

%package	fluidsynth
Summary:	Fluidsyth soundfont plugin for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}

%description	fluidsynth
Contains Fluidsynth soundfont plugin for Csound.

%package	dssi
Summary:	Disposable Soft Synth Interface (DSSI) plugin for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}
Requires:	dssi

%description	dssi
Disposable Soft Synth Interface (DSSI) plugin for Csound

%package	osc
Summary:	Open Sound Control (OSC) plugin for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}

%description	osc
Open Sound Control (OSC) plugin for Csound

%package	virtual-keyboard
Summary:	Virtual MIDI keyboard plugin for Csound
Group:		Sound/Utilities
Requires:	%{name} = %{version}-%{release}
Requires:	fltk

%description	virtual-keyboard
A virtual MIDI keyboard plugin for Csound

%package	doc
Summary:	Csound manual
Group:		Documentation
Obsoletes:	%{name}-manual
Requires:	%{name} = %{version}-%{release}
BuildArch:	noarch

%description	doc
Canonical Reference Manual for Csound.


%prep
%setup -q -n Csound%{version}
%patch0 -p1 -b .fixpython
%patch1 -p1 -b .no-usr-local
%patch2 -p1 -b .default-opcodedir
%patch3 -p1 -b .rtalsa
%patch4 -p1 -b .makebuild
%patch5 -p1 -b .64-bit-plugin-path
%patch6 -p1 -b .fix-conflicts
%patch7 -p1 -b .fix-local-install
%patch8 -p1 -b .enable-oggplay
%patch10 -p1 -b .default-pulse
%patch11 -p1 -b .bison26
tar xf %{SOURCE1}
(cd manual; unzip -q %{SOURCE2})


%build
cp %{SOURCE3} .
scons dynamicCsoundLibrary=1 \
      buildRelease=0 \
      noDebug=0 \
      disableGStabs=1 \
      buildInterfaces=1 \
      useGettext=1 \
      useALSA=1 \
      usePortAudio=0 \
      usePortMIDI=0 \
      useOGG=1 \
      useOSC=1 \
      useJack=1 \
      useFLTK=1 \
      buildVirtual=1 \
      useFluidsynth=1 \
      generatePdf=0 \
      buildCsound5GUI=1 \
      pythonVersion=%{py_ver} \
      buildPythonOpcodes=1 \
      buildPythonWrapper=1 \
      buildLuaWrapper=1 \
      buildTclcsound=1 \
      buildJavaWrapper=1 \
      buildDSSI=1 \
      buildUtilities=1 \
      prefix=%{_prefix} \
      customCCFLAGS="%{optflags}" \
      customCXXFLAGS="%{optflags}" \
      Word64=%{build64bit} \
      useDouble=%{useDouble}

# Generate javadoc
(cd interfaces; javadoc *.java)


%install
%{__python} install.py --prefix=%{_prefix} --instdir=%{buildroot} %{install64bit}
%{__rm} -f %{buildroot}%{_docdir}/%{name}/COPYING
%{__rm} -f %{buildroot}%{_docdir}/%{name}/ChangeLog
%{__rm} -f %{buildroot}%{_docdir}/%{name}/INSTALL
%{__rm} -f %{buildroot}%{_docdir}/%{name}/readme-csound5.txt
%{__rm} -f %{buildroot}%{_bindir}/uninstall-csound5
%{__rm} -f %{buildroot}%{_prefix}/csound5-*.md5sums

install -dm 755 %{buildroot}%{_javadir}
(cd %{buildroot}%{_javadir}; ln -s %{_libdir}/%{name}/java/csnd.jar .)

install -dm 644 %{buildroot}%{_javadocdir}/%{name}-java
%{__chmod} -R 755 %{buildroot}%{_javadocdir}/%{name}-java
(cd interfaces; tar cf - *.html csnd/*.html) | (cd %{buildroot}%{_javadocdir}/%{name}-java; tar xvf -)

%{_bindir}/aot-compile-rpm

%find_lang %{name}5


%post java
if [ -x %{_bindir}/rebuild-gcj-db ]; then
  %{_bindir}/rebuild-gcj-db
fi


%postun java
if [ -x %{_bindir}/rebuild-gcj-db ]; then
  %{_bindir}/rebuild-gcj-db
fi


%files -f %{name}5.lang
%doc COPYING ChangeLog readme-csound5.txt
%{_bindir}/atsa
%{_bindir}/cs-launcher
%{_bindir}/csb64enc
%{_bindir}/csbeats
%{_bindir}/csound
%{_bindir}/cvanal
%{_bindir}/dnoise
%{_bindir}/cs-envext
%{_bindir}/cs-extract
%{_bindir}/cs-extractor
%{_bindir}/het_export
%{_bindir}/het_import
%{_bindir}/hetro
%{_bindir}/lpanal
%{_bindir}/lpc_export
%{_bindir}/lpc_import
%{_bindir}/makecsd
%{_bindir}/cs-mixer
%{_bindir}/pvanal
%{_bindir}/pvlook
%{_bindir}/cs-scale
%{_bindir}/cs-scot
%{_bindir}/scsort
%{_bindir}/cs-sndinfo
%{_bindir}/cs-srconv
%{_bindir}/pv_export
%{_bindir}/pv_import
%{_libdir}/lib%{name}.so.5.2
%{_libdir}/libcsnd.so.5.2
%dir %{_libdir}/%{name}/plugins
%{_libdir}/%{name}/plugins/libampmidid.so
%{_libdir}/%{name}/plugins/libcellular.so
%{_libdir}/%{name}/plugins/libcontrol.so
%{_libdir}/%{name}/plugins/libchua.so
%{_libdir}/%{name}/plugins/libcs_date.so
%{_libdir}/%{name}/plugins/libcsladspa.so
%{_libdir}/%{name}/plugins/libdoppler.so
%{_libdir}/%{name}/plugins/libfareygen.so
%{_libdir}/%{name}/plugins/libfractalnoise.so
%{_libdir}/%{name}/plugins/libimage.so
%{_libdir}/%{name}/plugins/libjacko.so
%{_libdir}/%{name}/plugins/libmixer.so
%{_libdir}/%{name}/plugins/liboggplay.so
%{_libdir}/%{name}/plugins/libpy.so
%{_libdir}/%{name}/plugins/librtalsa.so
%{_libdir}/%{name}/plugins/librtpulse.so
%{_libdir}/%{name}/plugins/libscansyn.so
%{_libdir}/%{name}/plugins/libserial.so
%{_libdir}/%{name}/plugins/libsignalflowgraph.so
%{_libdir}/%{name}/plugins/libstdutil.so
%{_libdir}/%{name}/plugins/libsystem_call.so
%{_libdir}/%{name}/plugins/libudprecv.so
%{_libdir}/%{name}/plugins/libudpsend.so
%{_libdir}/%{name}/plugins/liburandom.so

%files devel
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/libcsnd.so

%files python
%{_libdir}/python%{pyver}/site-packages/*

%files java
%{_libdir}/lib_jcsound.so
%{_libdir}/%{name}/java/
%{_javadir}/csnd.jar
%attr(-,root,root) %{_libdir}/gcj/%{name}

%files javadoc
%doc %{_javadocdir}/%{name}-java

%files tk
%{_libdir}/%{name}/tcl/
%{_bindir}/matrix.tk
%{_bindir}/brkpt
%{_bindir}/linseg
%{_bindir}/tabdes
%{_bindir}/cstclsh
%{_bindir}/cswish

%files gui
%{_bindir}/csound5gui

%files fltk
%{_libdir}/%{name}/plugins/libwidgets.so

%files jack
%{_libdir}/%{name}/plugins/librtjack.so
%{_libdir}/%{name}/plugins/libjackTransport.so

%files fluidsynth
%{_libdir}/%{name}/plugins/libfluidOpcodes.so

%files dssi
%{_libdir}/%{name}/plugins/libdssi4cs.so

%files osc
%{_libdir}/%{name}/plugins/libosc.so

%files virtual-keyboard
%{_libdir}/%{name}/plugins/libvirtual.so

%files doc
%doc manual/copying.txt manual/credits.txt manual/readme.txt manual/news.txt
%doc manual/html/*
%doc manual/examples/*


%changelog

* Fri Jan 11 2013 umeabot <umeabot> 5.17.11-3.mga3
+ Revision: 348368
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Nov 29 2012 malo <malo> 5.17.11-2.mga3
+ Revision: 322797
- update RPM group

* Mon Aug 06 2012 sander85 <sander85> 5.17.11-1.mga3
+ Revision: 279254
- New version: 5.17.11.
- Rediff patches 1,4,6,8 and 10.
- Drop patches 11-14.
- Fix build with bison 2.6.
- Switch BR to lua5.1-devel.
- Fill doc package.

* Tue Apr 24 2012 fwang <fwang> 5.13.0-7.mga2
+ Revision: 233147
- add patch fixing CVE-2012-210[678]
- drop linkflaggs
- try build with ldflags

* Sat Apr 07 2012 fwang <fwang> 5.13.0-5.mga2
+ Revision: 229474
- fix typo
- add upstream patch to fix CVE-2012-0270: two buffer overflow flaws in getnum()

* Mon Sep 19 2011 fwang <fwang> 5.13.0-4.mga2
+ Revision: 145280
- rebuild for new libpng

* Mon Jul 11 2011 ahmad <ahmad> 5.13.0-3.mga2
+ Revision: 122089
- Move libcsnd.so to the -devel package

* Mon Jul 11 2011 fwang <fwang> 5.13.0-2.mga2
+ Revision: 122088
- rebuild for new fltk

* Sun Jul 10 2011 ahmad <ahmad> 5.13.0-1.mga2
+ Revision: 121758
- Update the manual sources (from the Fedora src.rpm)
- Update to 5.13.0
- Rediff patch0,1,2,4,6,7,10
- Drop patch9, fixed upstream
- Add BR flex, bison
- Update the file list

* Sun Jul 03 2011 fwang <fwang> 5.11-8.mga2
+ Revision: 117572
- we use 8.5 now by default
- rebuild for new csound

* Sun Feb 20 2011 eandry <eandry> 5.11-7.mga1
+ Revision: 54675
- drop buildroot
- bump release for upgrade
- imported package csound

